/*                      LEKCJA13.C
//---------------------------------------------------------------------------
Temat:
        Wybr wielu elementw 'SelectLoop'
//---------------------------------------------------------------------------
Funkcje:
        EXT(225) void SelectInit(     
        EXT(226) void SelectLoop(     
//---------------------------------------------------------------------------

EXT(226) void SelectLoop(      // 
             tCallBack func,   // funkcja Callback 
             void      *para,  // wskanik dla funkcji Callback 
             void      *edta,  // bufor dla danych tymczasowych
             ushort    esiz);  // wielko bufora

Opis:
    Funkcja pozwala uytkownikowi wybiera elementy przy pomocy opcji.
    przeszukuje ca list elementw rysunku.
    Jakie elementy s dozwolone musi by wczeniej ustalone przy pomocy 
    funkcji 'SelectInit()'.
    Wywoywana funkcja wewntrzna sygnalizuje przy pomocy wartoci
    return() jakie ma by dalsze dziaanie funkcji gwnej.

    return(CONTINUE_LOOP)  - kontynuacja ptli
    return(CALL_SAVECOUNT) - wywoanie funkcji 'savecount()
    return(BREAK_LOOP)     - przerwanie ptli

Przykady wywoania:
    SelectLoop(SelPid,&ent,edta,sizeof(edta));
//---------------------------------------------------------------------------

EXT(225) void SelectInit(       // 
             ulong     filter); // filtr wybierajcy elementy

Opis:
    Funkcja wskazuje elementy, ktre mog by wybierane przez uytkownika
    - podwietlone ikony typw elementw.

Przykad wywoania:
    SelectInit(0xffffffff);      // wszystkie typy podwietlone
*/

//---------------------------------------------------------------------------
#include "std.h"
#include "megatyp.h"
#include "megacad.h"
#define MAXPIDS 500
//---------------------------------------------------------------------------
char edta[32000];       // bufor dla danych wirtualnych
ulong pids[MAXPIDS];    // maksimum 500 elementw
ushort pidnum;          // licznik wczytanych elementw
//---------------------------------------------------------------------------
short SelPid(void *argptr )
{
    t_entity  *ent;

    ent = argptr;
    pids[pidnum] = ent->id;
    pidnum++;
    if(pidnum == MAXPIDS)
        return(BREAK_LOOP);
    else
        return(CONTINUE_LOOP);
}
//---------------------------------------------------------------------------
short DoDraw(void *ptr )
{
    DrawEntities(pids,pidnum);
}
//---------------------------------------------------------------------------
short main(char *filename,char *args)
{
    t_entity ent;

    pidnum = 0;
    SetFuncText("migotanie");
    MouseHelp("wybr elementw","miganie",HLP_INV(0,0,0));
    SelectInit((1<<E_LINE)|(1<<E_POINT));
              // znalezienie elementu powoduje wywoanie 'SelPid'        
    SelectLoop(SelPid,&ent,edta,sizeof(edta));
    Blink(DoDraw,NULL);
    return(0);
}
//---------------------------------------------------------------------------
